# Route Collections

## Introduction

A RouteCollection is an object that represents a group of Routes. A route collection may include a path prefix to be prepended to the path of each route in the collection. Further, a route collection may accept other route collections as children, effectively creating a routing tree.

The most common use of route collections is to group routes with a common path prefix.

## **Class Synopsis**

```
class RouteCollection
{
    constructor(string prefix, array routes = [], array collections = []);

    addRoute(Route route);
    addRoutes(Route[] routes);
    addCollection(RouteCollection collection);
    addCollections(RouteCollection[] collections);

    findRouteByPath(string path);
    findRouteByName(string name, bool deep = false);
    findCollectionByPrefix(string prefix);

    getRoutes() : Route[];
    getCollections() : RouteCollection[];
    getFlattenedRoutes() : Route[];
    getFlattenedCollections() : RouteCollection[];
    getPathPrefix() : string;
    getParentCollection() : RouteCollection|null;

    setPathPrefix(string prefix);
    setParentCollection(RouteCollection collection);
}
```

## Examples

### **Example: Grouping routes with a shared path prefix**

```
let routes = new RouteCollection('/sandbox', [
    new Route('sandbox.index', '/index', 'Sandbox.Sandbox.index'),  // Matches #/sandbox/index
    new Route('sandbox.demo' '/demo', 'Sandbox.Sandbox.demo')       // Matches #/sandbox/demo
];
```

### **Example: Chaining collections declaratively**

```
let routes = new RouteCollection('/sandbox', [
    new Route('sandbox.index', '/index', 'Sandbox.Sandbox.index')  // Matches #/sandbox/index
], [
    new RouteCollection('/section', [
        new Route('sandbox.demo', '/demo', 'Sandbox.Sandbox.demo') // Matches #/sandbox/section/demo
    ])
]);
```

### **Example: Chaining collections programmatically**

```
let sandboxRoutes = new RouteCollection('/sandbox', [
    // Matches #/sandbox/index
    new Route('sandbox.index', '/index', 'Sandbox.Sandbox.index')
]);

let sectionRoutes = new RouteCollection('/section', [
    // Matches #/section/demo
    new Route('sandbox.demo', '/demo', 'Sandbox.Sandbox.demo')
]);

sandboxRoutes.addCollection(sectionRoutes);

// sandbox.index still matches #/sandbox/index
// sandbox.demo now matches #/sandbox/section/demo
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.elentra.org/ejs/1.0/guide/routing/route-collections.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
